module.exports = config =>
  config.set({
    frameworks: ['mocha'],
    browsers: ['ChromeHeadless'],
    urlRoot: '/',
    // browsers: ['Chrome'],
    files: [
      { pattern: 'dist/*.wasm', included: false, type: 'wasm' },
      { pattern: 'dist/libsignal-worker.js', included: false },
      { pattern: 'dist/*.js.map', included: false },
      'dist/test.js',
    ],
    preprocessors: {
      'dist/test.js': ['sourcemap', 'coverage'],
    },
    logLevel: config.LOG_WARNING,
    reporters: ['progress', 'coverage'],
    coverageReporter: {
      dir: 'coverage/',
      reporters: [{ type: 'html', subdir: 'report-html' }],
    },
  });
