import { cryptoInternals } from '../src/crypto.js';

import testIdentityKeyStore from './store/identity_key_store.test.js';
import SignalProtocolStore from './store/in_memory_signal_protocol_store.test.js';
import testPreKeyStore from './store/pre_key_store.test.js';
import testSessionStore from './store/session_store.test.js';
import testSignedPreKeyStore from './store/signed_pre_key_store.test.js';

describe('SignalProtocolStore', function () {
  var store = new SignalProtocolStore();
  var registrationId = 1337;
  var identityKey = {
    pubKey: cryptoInternals.getRandomBytes(33),
    privKey: cryptoInternals.getRandomBytes(32),
  };
  before(function () {
    store.put('registrationId', registrationId);
    store.put('identityKey', identityKey);
  });
  testIdentityKeyStore(store, registrationId, identityKey);
  testPreKeyStore(store);
  testSignedPreKeyStore(store);
  testSessionStore(store);
});
